#include <Wire.h>
#define SLAVE_ADDRESS 0x04
#include <Servo.h> 
Servo myservo;

int N = 0; //
byte A = 0; //

int ledPin = 13;
int st ,flag = 0, index = 0;
char buf[8];
byte b[1];

void receiveData(int byteCount){
   while(Wire.available()>0) 
   {
     N = Wire.read();
     flag = 1;   
   }
}

void sendData(){
 Wire.write(b,1); 
}


void setup(){
   myservo.attach(9); 
   Serial.begin(9600);  
   Wire.begin(SLAVE_ADDRESS);
   Wire.onReceive(receiveData); 
   Wire.onRequest(sendData);
   myservo.write(170);        
}

int y = 0;
void serva(int n){
  for(int i = 0; i < n; i ++){
    if(y % 2 == 0){
      myservo.write(10);  
      delay(2000);
      y ++;
    }else{ 
      myservo.write(170);  
      delay(2000);
      y ++;
   }   
  }
 }



int UL(int IN){ //      
  int cm=0;
  int im=0;
  pinMode(IN, OUTPUT);
  digitalWrite(IN, HIGH);
  delayMicroseconds(10);
  digitalWrite(IN, LOW);
  pinMode(IN, INPUT);
  im = pulseIn(IN, HIGH, 40000);
  cm = im/58;
  delay(100);
  return cm;  
}

void zapret(){
  if(analogRead(0) > 400){
    Serial.print(" z ");
    b[0] = 0;
    sendData();
    delay(100);
    b[0] = 5;
    sendData();
    delay(1000);
    b[0] = 4;
    sendData();
    delay(2000);
  }
}


void loop(){ 
 int i = 0; 
 i = 0;
 while(i <= 19){     // 
  receiveData(1);
  sendData();
  Serial.print(b[0]);
  Serial.print("   ");
  //Serial.print(analogRead(0));

  zapret();
  if(UL(11) > 30){       // 
    if(UL(10) < 15){
      b[0] = 0;
      pinMode(ledPin, OUTPUT);
      sendData();
      delay(100); 
    }
    zapret();
    b[0] = 2;
    sendData(); 
  }else
    if(UL(10) > 15){  //
      receiveData(1);
      zapret();
      if(UL(10) < 15){
        b[0] = 0;
        pinMode(ledPin, OUTPUT);
        sendData();
        delay(500); 
      }
      N = 0;
      b[0] = 1;
      sendData();
  }

  if((UL(11) <= 20) && (UL(10) <= 15) && (UL(8) > 30)){      //
    if(UL(10) < 15){
      b[0] = 0;
      pinMode(ledPin, OUTPUT);
      sendData();
      delay(100); 
    }
    zapret();
    b[0] = 3;
    sendData();
  } 
  if((UL(11) <= 20) && (UL(10) <= 15) && (UL(8) <= 20)){     // 180
        b[0] = 3;
        sendData();
        delay(2000);
        b[0] = 3;
        sendData();
        delay(2000);
    }
  i ++; 
 }

 while((i > 19) && (i <= 32)){              // 
  receiveData(1);
  sendData();
  Serial.print(b[0]);
  Serial.print("   ");
  Serial.print("  L  ");

  zapret(); 
  if(UL(8) > 30){                  // 
    if(UL(10) < 15){
      b[0] = 0;
      sendData();
      delay(100); 
    }
    zapret();
    b[0] = 3;
    sendData(); 
  }else
    if(UL(10) > 15){               //
      receiveData(1);
      zapret();
      if(UL(10) < 15){
        b[0] = 0;
        pinMode(ledPin, OUTPUT);
        sendData();
        delay(100); 
      }
      N = 0;
      b[0] = 1;
      sendData();
      delay(100);
  }

  if((UL(8) <= 20) && (UL(10) <= 15) && (UL(11) > 30)){      //
    if(UL(10) < 15){
      b[0] = 0;
      pinMode(ledPin, OUTPUT);
      sendData();
      delay(100); 
    }
    zapret();
    b[0] = 2;
    sendData();
  }
  if((UL(11) <= 20) && (UL(10) <= 15) && (UL(8) <= 20)){     // 180
        b[0] = 2;
        sendData();
        delay(2000);
        b[0] = 2;
        sendData();
        delay(2000);
    }
  i ++;
 }
}  
